unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1Resize(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  y, x: Integer;
begin
  for y := 0 to 9 do
    for x := 0 to 9 do
      StringGrid1.Cells[x, y] := IntToStr(y * 10 + x);
end;

procedure TForm1.StringGrid1Resize(Sender: TObject);
var
  ARow, UsedHeigth, AHeight, UsedWidth, ACol, AWidth: Integer;
begin
  UsedHeigth := 0;
  for ARow := 0 to 9 do
  begin
    AHeight := (StringGrid1.ClientHeight - UsedHeigth) div (10 - ARow);
    StringGrid1.RowHeights[ARow] := AHeight;
    Inc(UsedHeigth, AHeight);
  end;

  UsedWidth := 0;
  for ACol := 0 to 9 do
  begin
    AWidth := (StringGrid1.ClientWidth - UsedWidth) div (10 - ACol);
    StringGrid1.ColWidths[ACol] := AWidth;
    Inc(UsedWidth, AWidth);
  end;
end;

end.

